#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <ucontext.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>
#include <string>
#include <boost/asio.hpp>

using namespace std;

int
main(int argc, char *argv[])
{
  int fd;


  // #########################################################
  // On test s'il y a un argument sur la ligne de commande pour avoir un message à échanger
  // #########################################################
  //assert(argc == 2);
  if (argc != 2) {
    fprintf(stderr, "Usage %s <nom fifo>\n", argv[0]);
    exit(2);
  }
  
  if (mkfifo(argv[1], 0644)==-1) {
    fprintf(stderr, "probleme avec la création du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }
  fd = open(argv[1], O_RDONLY);
  if (fd <= 0) {
    fprintf(stderr, "probleme avec l'ouverture du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }

  boost::asio::io_service service;
  boost::asio::posix::stream_descriptor streampipe(service, fd);

  boost::system::error_code error;
  char buf;

  while (1) {
    read(streampipe, boost::asio::buffer(&buf,1), error);
    if (error == boost::asio::error::eof){
	cout << "fermeture du pipe par le pair" << endl;
	break;
    }
    if (error) {
      cerr << "Il y a un problème de lecture sur le pipe : " << error.message() << endl;
      exit(1);
    }
    cout << "J'ai reçu : '" << buf << "'" << endl;
  }

  cout << "Fin de la liaison" << endl;

  streampipe.close();
  close(fd);

  if (unlink(argv[1])==-1) {
    fprintf(stderr, "Probleme avec la destruction du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }  

  return 0;
}
